-- Binary to 7 segment LED Decoder
-- oCif[^7ZOgLEDp̃f[^ɕϊ܂B
-- enable0ɂƏB
-- _ZOg1ŕ\Ă邪Aۂɂ0œ_̂ŏ̃t@CŔ]Ă܂B

library ieee;
use ieee.std_logic_1164.all;

entity B27segDec is
	port(
		binary : in std_logic_vector(3 downto 0);
		enable : in std_logic;
		segdecout : out std_logic_vector(6 downto 0) -- a,b,c,d,e,f,g segment without dot.
	);
end B27segDec;

architecture RTL of B27segDec is
begin
	process(binary, enable) begin 
		if enable='1' then
			case binary is
			when "0000" =>  -- 0
				segdecout <= "1111110";
			when "0001" => -- 1
				segdecout <= "0110000";
			when "0010" => -- 2
				segdecout <= "1101101";
			when "0011" => -- 3
				segdecout <= "1111001";
			when "0100" => -- 4
				segdecout <= "0110011";
			when "0101" => -- 5
				segdecout <= "1011011";
			when "0110" => -- 6
				segdecout <= "1011111";
			when "0111" => -- 7
				segdecout <= "1110000";
			when "1000" => -- 8
				segdecout <= "1111111";
			when "1001" => -- 9
				segdecout <= "1111011";
			when "1010" => -- A
				segdecout <= "1110111";
			when "1011" => -- B b
				segdecout <= "0011111";
			when "1100" => -- C
				segdecout <= "1001110";
			when "1101" => -- D d
				segdecout <= "0111101";
			when "1110" => -- E
				segdecout <= "1001111";
			when others => -- F
				segdecout <= "1000111";
			end case;
		else
			segdecout <= "0000000";
		end if;
	end process;
end RTL;
